/**
 *Board and movement of pieces
 *@author arghavan soleymanpour
 *@version 2.0
 */
package Pieces;

import Main.Board;

import java.util.ArrayList;

public class King extends Piece {


    public King(int x, int y, boolean isWhite, Board board) {
        super(x, y, isWhite, board);
    }

    @Override
    public boolean isValidMove(int dx, int dy) {
//        if(!isCanMove(dx, dy)) return false;
//        for(int i = Math.min(dx,getX());i< Math.max(dx,getX());i++){
//            for(int j =Math.min(dy,getY());i < Math.max(dy,getY());j++){
//                if(getBoard().getBoard()[i][j]!=null) return false;
//            }
//        }
        ArrayList<int[]> moves = moves();
        for (int m[] : moves){
            if(m[0]==dx && m[1] == dy){
                return true;
            }
        }
        return false;
    }


    private boolean isAttacked(int x , int y){
        for (int i = 0 ; i < 8 ; i++){
            for (int j = 0 ; j < 8 ; j++){
                Piece p = getBoard().getBoard()[i][j];
                if(p!=null && !(p instanceof King)){
                    if(p.isWhite() && isBlack()){
                        if(p.isValidMove(x,y)) return true;
                    }else if(p.isBlack() && isWhite()){
                        if(p.isValidMove(x,y)) return true;
                    }
                }
            }
        }
        return false;
    }
    @Override
    public ArrayList<int[]> moves() {
        ArrayList<int[]> move = new ArrayList<>();
        int x = getX();
        int y = getY();
        int posx[]={x,x,x+1,x+1,x+1,x-1,x-1,x-1};
        int posy[]={y-1,y+1,y-1,y,y+1,y-1,y,y+1};
        for(int i=0;i<8;i++){
            if((posx[i]>=0&&posx[i]<8&&posy[i]>=0&&posy[i]<8)){
                if(getBoard().isEmpty(posx[i],posy[i]) || (getBoard().getColor(posx[i],posy[i])==2 && this.isWhite()) ||(getBoard().getColor(posx[i],posy[i])==1 && isBlack()) )
                {
                    if(!isAttacked(posx[i],posy[i])){
                        move.add(new int[]{posx[i], posy[i]});
                    }

                }
            }
        }
        return move;
    }

    @Override
    public String toString() {
        return "K";
    }
}
